import { defineStore } from "pinia"
import { reactive, ref } from "vue"
import { checkLoggedIn, getAtk } from "@/stores/userinfo"
import { request } from "@/scripts/request"

export const useChannels = defineStore("channels", () => {
  const done = ref(false)

  const show = reactive({
    editor: false,
    delete: false
  })

  const related_to = reactive<{ edit_to: any; delete_to: any }>({
    edit_to: null,
    delete_to: null
  })

  const available = ref<any[]>([])
  const current = ref<any>(null)
  const messages = ref<any[]>([])

  async function list() {
    if (!(await checkLoggedIn())) return

    const res = await request("messaging", "/api/channels/me/available", {
      headers: { Authorization: `Bearer ${await getAtk()}` }
    })
    if (res.status !== 200) {
      throw new Error(await res.text())
    } else {
      available.value = await res.json()
    }
  }

  return { done, show, related_to, available, current, messages, list }
})